bitbake/lib/toaster/toastergui/urls.py
#
# BitBake Toaster Implementation
#
# Copyright (C) 2013-2017    Intel Corporation
#
# SPDX-License-Identifier: GPL-2.0-only
#

from django.urls import re_path as url
from django.views.generic import RedirectView

from toastergui import tables
from toastergui import buildtables
from toastergui import typeaheads
from toastergui import api
from toastergui import widgets
from toastergui import views

urlpatterns = [
        # landing page
        url(r'^landing/$', views.landing, name='landing'),

        url(r'^builds/$',
            tables.AllBuildsTable.as_view(template_name="builds-toastertable.html"),
            name='all-builds'),

        # build info navigation
        url(r'^build/(?P<build_id>\d+)$', views.builddashboard, name="builddashboard"),
        url(r'^build/(?P<build_id>\d+)/tasks/$',
            buildtables.BuildTasksTable.as_view(
                template_name="buildinfo-toastertable.html"),
            name='tasks'),

        url(r'^build/(?P<build_id>\d+)/task/(?P<task_id>\d+)$', views.task, name='task'),

        url(r'^build/(?P<build_id>\d+)/recipes/$',
            buildtables.BuiltRecipesTable.as_view(
                template_name="buildinfo-toastertable.html"),
            name='recipes'),

        url(r'^build/(?P<build_id>\d+)/recipe/(?P<recipe_id>\d+)/active_tab/(?P<active_tab>\d{1})$', views.recipe, name='recipe'),

        url(r'^build/(?P<build_id>\d+)/recipe/(?P<recipe_id>\d+)$', views.recipe, name='recipe'),
        url(r'^build/(?P<build_id>\d+)/recipe_packages/(?P<recipe_id>\d+)$', views.recipe_packages, name='recipe_packages'),

        url(r'^build/(?P<build_id>\d+)/packages/$',
            buildtables.BuiltPackagesTable.as_view(
                template_name="buildinfo-toastertable.html"),
            name='packages'),

        url(r'^build/(?P<build_id>\d+)/package/(?P<package_id>\d+)$', views.package_built_detail,
                name='package_built_detail'),
        url(r'^build/(?P<build_id>\d+)/package_built_dependencies/(?P<package_id>\d+)$',
            views.package_built_dependencies, name='package_built_dependencies'),
        url(r'^build/(?P<build_id>\d+)/package_included_detail/(?P<target_id>\d+)/(?P<package_id>\d+)$',
            views.package_included_detail, name='package_included_detail'),
        url(r'^build/(?P<build_id>\d+)/package_included_dependencies/(?P<target_id>\d+)/(?P<package_id>\d+)$',
            views.package_included_dependencies, name='package_included_dependencies'),
        url(r'^build/(?P<build_id>\d+)/package_included_reverse_dependencies/(?P<target_id>\d+)/(?P<package_id>\d+)$',
            views.package_included_reverse_dependencies, name='package_included_reverse_dependencies'),

        url(r'^build/(?P<build_id>\d+)/target/(?P<target_id>\d+)$',
            buildtables.InstalledPackagesTable.as_view(
                template_name="target.html"),
            name='target'),


        url(r'^dentries/build/(?P<build_id>\d+)/target/(?P<target_id>\d+)$', views.xhr_dirinfo, name='dirinfo_ajax'),
        url(r'^build/(?P<build_id>\d+)/target/(?P<target_id>\d+)/dirinfo$', views.dirinfo, name='dirinfo'),
        url(r'^build/(?P<build_id>\d+)/target/(?P<target_id>\d+)/dirinfo_filepath/_(?P<file_path>(?:/[^/\n]+)*)$', views.dirinfo, name='dirinfo_filepath'),
        url(r'^build/(?P<build_id>\d+)/configuration$', views.configuration, name='configuration'),
        url(r'^build/(?P<build_id>\d+)/configvars$', views.configvars, name='configvars'),
        url(r'^build/(?P<build_id>\d+)/buildtime$',
            buildtables.BuildTimeTable.as_view(
                template_name="buildinfo-toastertable.html"),
            name='buildtime'),

        url(r'^build/(?P<build_id>\d+)/cputime$',
            buildtables.BuildCPUTimeTable.as_view(
                template_name="buildinfo-toastertable.html"),
            name='cputime'),

        url(r'^build/(?P<build_id>\d+)/diskio$',
            buildtables.BuildIOTable.as_view(
                template_name="buildinfo-toastertable.html"),
            name='diskio'),

        # image information dir
        url(r'^build/(?P<build_id>\d+)/target/(?P<target_id>\d+)/packagefile/(?P<packagefile_id>\d+)$',
             views.image_information_dir, name='image_information_dir'),

        # build download artifact
        url(r'^build/(?P<build_id>\d+)/artifact/(?P<artifact_type>\w+)/id/(?P<artifact_id>\w+)', views.build_artifact, name="build_artifact"),

        # project URLs
        url(r'^newproject/$', views.newproject, name='newproject'),

        url(r'^cmdline/$', views.CommandLineBuilds.as_view(), name='cmdlines'),
        url(r'^projects/$',
            tables.ProjectsTable.as_view(template_name="projects-toastertable.html"),
            name='all-projects'),

        url(r'^project/(?P<pid>\d+)/$', views.project, name='project'),
        url(r'^project/(?P<pid>\d+)/configuration$', views.projectconf, name='projectconf'),
        url(r'^project/(?P<pid>\d+)/builds/$',
            tables.ProjectBuildsTable.as_view(template_name="projectbuilds-toastertable.html"),
            name='projectbuilds'),

        url(r'^newproject_specific/(?P<pid>\d+)/$', views.newproject_specific, name='newproject_specific'),
        url(r'^project_specific/(?P<pid>\d+)/$', views.project_specific, name='project_specific'),
        url(r'^landing_specific/(?P<pid>\d+)/$', views.landing_specific, name='landing_specific'),
        url(r'^landing_specific_cancel/(?P<pid>\d+)/$', views.landing_specific_cancel, name='landing_specific_cancel'),

        # the import layer is a project-specific functionality;
        url(r'^project/(?P<pid>\d+)/importlayer$', views.importlayer, name='importlayer'),

        # the table pages that have been converted to ToasterTable widget
        url(r'^project/(?P<pid>\d+)/machines/$',
            tables.MachinesTable.as_view(template_name="generic-toastertable-page.html"),
            name="projectmachines"),

        url(r'^project/(?P<pid>\d+)/softwarerecipes/$',
            tables.SoftwareRecipesTable.as_view(template_name="generic-toastertable-page.html"),
            name="projectsoftwarerecipes"),

        url(r'^project/(?P<pid>\d+)/images/$',
            tables.ImageRecipesTable.as_view(template_name="generic-toastertable-page.html"), name="projectimagerecipes"),

        url(r'^project/(?P<pid>\d+)/customimages/$',
            tables.CustomImagesTable.as_view(template_name="generic-toastertable-page.html"), name="projectcustomimages"),

        url(r'^project/(?P<pid>\d+)/newcustomimage/$',
            tables.NewCustomImagesTable.as_view(template_name="newcustomimage.html"),
            name="newcustomimage"),

        url(r'^project/(?P<pid>\d+)/layers/$',
            tables.LayersTable.as_view(template_name="generic-toastertable-page.html"),
            name="projectlayers"),

        url(r'^project/(?P<pid>\d+)/layer/(?P<layerid>\d+)$',
            views.layerdetails, name='layerdetails'),

        url(r'^project/(?P<pid>\d+)/layer/(?P<layerid>\d+)/recipes/$',
            tables.LayerRecipesTable.as_view(template_name="generic-toastertable-page.html"),
            { 'table_name': tables.LayerRecipesTable.__name__.lower(),
              'title' : 'All recipes in layer' },
             name=tables.LayerRecipesTable.__name__.lower()),

        url(r'^project/(?P<pid>\d+)/layer/(?P<layerid>\d+)/machines/$',
            tables.LayerMachinesTable.as_view(template_name="generic-toastertable-page.html"),
            { 'table_name': tables.LayerMachinesTable.__name__.lower(),
              'title' : 'All machines in layer' },
            name=tables.LayerMachinesTable.__name__.lower()),


        url(r'^project/(?P<pid>\d+)/distros/$',
            tables.DistrosTable.as_view(template_name="generic-toastertable-page.html"),
            name="projectdistros"),


        url(r'^project/(?P<pid>\d+)/customrecipe/(?P<custrecipeid>\d+)/selectpackages/$',
            tables.SelectPackagesTable.as_view(), name="recipeselectpackages"),


        url(r'^project/(?P<pid>\d+)/customrecipe/(?P<custrecipeid>\d+)$',
            tables.SelectPackagesTable.as_view(template_name="customrecipe.html"),
            name="customrecipe"),

        url(r'^project/(?P<pid>\d+)/customrecipe/(?P<recipe_id>\d+)/download$',
            views.customrecipe_download,
            name="customrecipedownload"),

        url(r'^project/(?P<pid>\d+)/recipe/(?P<recipe_id>\d+)$',
            tables.PackagesTable.as_view(template_name="recipedetails.html"),
            name="recipedetails"),

        # typeahead api end points
        url(r'^xhr_typeahead/(?P<pid>\d+)/layers$',
            typeaheads.LayersTypeAhead.as_view(), name='xhr_layerstypeahead'),
        url(r'^xhr_typeahead/(?P<pid>\d+)/machines$',
            typeaheads.MachinesTypeAhead.as_view(), name='xhr_machinestypeahead'),
        url(r'^xhr_typeahead/(?P<pid>\d+)/recipes$',
            typeaheads.RecipesTypeAhead.as_view(), name='xhr_recipestypeahead'),
        url(r'^xhr_typeahead/projects$',
            typeaheads.ProjectsTypeAhead.as_view(), name='xhr_projectstypeahead'),
        url(r'^xhr_typeahead/gitrev$',
            typeaheads.GitRevisionTypeAhead.as_view(),
            name='xhr_gitrevtypeahead'),

        url(r'^xhr_typeahead/(?P<pid>\d+)/distros$',
            typeaheads.DistrosTypeAhead.as_view(), name='xhr_distrostypeahead'),

        url(r'^xhr_testreleasechange/(?P<pid>\d+)$', views.xhr_testreleasechange,
            name='xhr_testreleasechange'),
        url(r'^xhr_configvaredit/(?P<pid>\d+)$', views.xhr_configvaredit,
            name='xhr_configvaredit'),

        url(r'^xhr_layer/(?P<pid>\d+)/(?P<layerversion_id>\d+)$',
            api.XhrLayer.as_view(),
            name='xhr_layer'),

        url(r'^xhr_layer/(?P<pid>\d+)$',
            api.XhrLayer.as_view(),
            name='xhr_layer'),

        # JS Unit tests
        url(r'^js-unit-tests/$', views.jsunittests, name='js-unit-tests'),

        # image customisation functionality

bitbake/lib/toaster/toastermain/urls.py
#
# BitBake Toaster Implementation
#
# Copyright (C) 2013        Intel Corporation
#
# SPDX-License-Identifier: GPL-2.0-only
#

from django.urls import re_path as url, include
from django.views.generic import RedirectView, TemplateView
from django.views.decorators.cache import never_cache
import bldcollector.views

import logging

logger = logging.getLogger("toaster")

# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()

urlpatterns = [

    # Examples:
    # url(r'^toaster/', include('toaster.foo.urls')),

    # Uncomment the admin/doc line below to enable admin documentation:
    # url(r'^admin/doc/', include('django.contrib.admindocs.urls')),


    url(r'^logs/', include('log_viewer.urls')),

    # This is here to maintain backward compatibility and will be deprecated
    # in the future.
    url(r'^orm/eventfile$', bldcollector.views.eventfile),

    url(r'^health$', TemplateView.as_view(template_name="health.html"), name='Toaster Health'),

    # if no application is selected, we have the magic toastergui app here
    url(r'^$', never_cache(RedirectView.as_view(url='/toastergui/', permanent=True))),
]

import toastermain.settings

if toastermain.settings.FRESH_ENABLED:
    urlpatterns.insert(1, url(r'', include('fresh.urls')))
    #logger.info("Enabled django-fresh extension")

if toastermain.settings.DEBUG_PANEL_ENABLED:
    import debug_toolbar
    urlpatterns.insert(1, url(r'', include(debug_toolbar.urls)))
    #logger.info("Enabled django_toolbar extension")

urlpatterns = [
    # Uncomment the next line to enable the admin:
    url(r'^admin/', admin.site.urls),
] + urlpatterns

# Automatically discover urls.py in various apps, beside our own
# and map module directories to the patterns

import os
currentdir = os.path.dirname(__file__)
for t in os.walk(os.path.dirname(currentdir)):
    #if we have a virtualenv skip it to avoid incorrect imports
    if 'VIRTUAL_ENV' in os.environ and os.environ['VIRTUAL_ENV'] in t[0]:
        continue

    if "urls.py" in t[2] and t[0] != currentdir:
        modulename = os.path.basename(t[0])
        # make sure we don't have this module name in
        conflict = False
        for p in urlpatterns:
            if p.pattern.regex.pattern == '^' + modulename + '/':
                conflict = True
        if not conflict:
            urlpatterns.insert(0, url(r'^' + modulename + '/', include ( modulename + '.urls')))
        else:
            logger.warning("Module \'%s\' has a regexp conflict, was not added to the urlpatterns" % modulename)

from pprint import pformat
#logger.debug("urlpatterns list %s", pformat(urlpatterns))

bitbake/lib/toaster/toastergui/forms.py
#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# BitBake Toaster UI tests implementation
#
# Copyright (C) 2023 Savoir-faire Linux
#
# SPDX-License-Identifier: GPL-2.0-only
#

from django import forms
from django.core.validators import FileExtensionValidator

class LoadFileForm(forms.Form):
    eventlog_file = forms.FileField(widget=forms.FileInput(attrs={'accept': '.json'}))

bitbake/lib/toaster/toastergui/templates/command_line_builds.html
{% extends "base.html" %}
{% load projecttags %}
{% load humanize %}
{% load static %}

{% block title %} Import Builds from eventlogs - Toaster {% endblock %}

{% block pagecontent %}

<div class="container-fluid">
    <div id="overlay" class="hide">
        <div class="spinner">
            <div class="fa-spin">
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <div class="page-header">
                <div class="row">
                    <div class="col-md-6">
                        <h1>Import command line builds</h1>
                    </div>
                    {% if import_all %}
                    <div class="col-md-6">
                        <button id="import_all" type="button" class="btn btn-primary navbar-btn navbar-right">
                            <span class="glyphicon glyphicon-upload" style="vertical-align: top;"></span> Import All
                        </button>
                    </div>
                    {% endif %}
                </div>
            </div>
            {% if messages %}
            <div class="row-fluid" id="empty-state-{{table_name}}">
                {% for message in messages %}
                <div class="alert alert-danger">{{message}}</div>
                {%endfor%}
            </div>
            {% endif %}
            <div class="row">
                <h4 style="margin-left: 15px;"><strong>Import eventlog file</strong></h4>
                <form method="POST" enctype="multipart/form-data" action="{% url 'cmdlines' %}" id="form_file">
                    {% csrf_token %}
                    <div class="col-md-6" style="padding-left: 20px;">
                        <div class="row">
                            <input type="hidden" value="{{dir}}" name="dir">
                            <div class="col-md-3"> {{ form.eventlog_file}}  </div>
                        </div>
                        <div class="row" style="padding-top: 10px;">
                            <div class="col-md-6">
                                <button id="file_import" type="submit" disabled="disabled" class="btn btn-default navbar-btn" >
                                    <span class="glyphicon glyphicon-upload" style="vertical-align: top;"></span> Import
                                </button>
                            </div>
                        </div>
                    </div>
                </form>
            </div>

            <div class="row" style="padding-top: 20px;">
                <div class="col-md-8 ">
                    <h4><strong>Eventlogs from existing build directory: </strong>
                        <a href="#" data-toggle="tooltip" title="{{dir}}">
                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-info-circle" viewBox="0 0 16 16" data-toggle="tooltip">
                                <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14m0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16"/>
                                <path d="m8.93 6.588-2.29.287-.082.38.45.083c.294.07.352.176.288.469l-.738 3.468c-.194.897.105 1.319.808 1.319.545 0 1.178-.252 1.465-.598l.088-.416c-.2.176-.492.246-.686.246-.275 0-.375-.193-.304-.533zM9 4.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0"/>
                            </svg>
                        </a>
                    </h4>
                    {% if files %}
                    <div class="table-responsive">
                        <table class="table col-md-6 table-bordered table-hover" id="eventlog-table" style="border-collapse: collapse;">
                            <thead>
                            <tr class="row">
                                <th scope="col">Name</th>
                                <th scope="col">Size</th>
                                <th scope="col">Action</th>
                            </tr>
                            </thead>
                            <tbody>
                                {% for file in files %}
                                <tr class="row" style="height: 48px;">
                                    <th scope="row" class="col-md-4" style="vertical-align: middle;">
                                        <input type="hidden" value="{{file.name}}" name="{{file.name}}">{{file.name}}
                                    </th>
                                    <td class="col-md-4 align-middle" style="vertical-align: middle;">{{file.size|filesizeformat}}</td>
                                    <td class="col-md-4 align-middle" style="vertical-align: middle;">
                                        {% if file.imported == True and file.build_id is not None %}
                                            <a href="{% url 'builddashboard' file.build_id %}">Build Details</a>
                                        {% elif request.session.file == file.name or request.session.all_builds %}
                                            <a data-toggle="tooltip" title="Build in progress">
                                                <span class="glyphicon glyphicon-upload" style="font-size: 18px; color:grey"></span>
                                            </a>
                                        {%else%}
                                            <a onclick="_ajax_update('{{file.name}}', false, '{{dir}}')" data-toggle="tooltip" title="Import File">
                                                <span class="glyphicon glyphicon-upload" style="font-size: 18px;"></span>
                                            </a>
                                        {%endif%}
                                    </td>
                                </tr>
                                {% endfor%}
                            </tbody>
                        </table>
                    </div>
                    {% else %}
                    <div class="row-fluid" id="empty-state-{{table_name}}">
                        <div class="alert alert-info">Sorry - no files found</div>
                    </div>
                    {%endif%}
                </div>
            </div>
        </div>
    </div>
</div>

<link rel="stylesheet" href="{% static 'css/jquery.dataTables-1.13.8.min.css' %}" type='text/css'/>
<script src="{% static 'js/jquery.dataTables-1.13.8.min.js' %}"> </script>
<script>

function _ajax_update(file, all, dir){
    function getCookie(name) {
        var cookieValue = null;
        if (document.cookie && document.cookie !== '') {
            var cookies = document.cookie.split(';');
            for (var i = 0; i < cookies.length; i++) {
                var cookie = jQuery.trim(cookies[i]);
                // Does this cookie string begin with the name we want?
                if (cookie.substring(0, name.length + 1) === (name + '=')) {
                    cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                    break;
                }
            }
        }
    return cookieValue;
    }
    var csrftoken = getCookie('csrftoken');

    function csrfSafeMethod(method) {
        // these HTTP methods do not require CSRF protection
        return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
    }
    $.ajaxSetup({
        beforeSend: function (xhr, settings) {
            if (!csrfSafeMethod(settings.type) && !this.crossDomain) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken);
            }
        }
    });

    $.ajax({
        url:'/toastergui/cmdline/',
        type: "POST",
        data: {file: file, all: all, dir: dir},
        success:function(data){
            if (data['response']=='building'){
                location.reload()
            } else {
                window.location = '/toastergui/builds/'
            }
        },
        complete:function(data){
        },
        error:function (xhr, textStatus, thrownError){
            console.log('fail');
        }
    });
}

$('#import_all').on('click', function(){
    _ajax_update("{{files | safe}}", true, "{{dir | safe}}");
});


$('#import_page').hide();

$(function () {
  $('[data-toggle="tooltip"]').tooltip()
})


$("#id_eventlog_file").change(function(){
    $('#file_import').prop("disabled", false);
    $('#file_import').addClass('btn-primary')
    $('#file_import').removeClass('btn-default')
})

$(document).ajaxStart(function(){
    $('#overlay').removeClass('hide');
    window.setTimeout(
        function() {
            window.location = '/toastergui/builds/'
        }, 10000)
});

$( "#form_file").on( "submit", function( event ) {
    $('#overlay').removeClass('hide');
    window.setTimeout(
        function() {
            window.location = '/toastergui/builds/'
        }, 10000)
});

$(document).ready( function () {
    $('#eventlog-table').DataTable({order: [[0, 'desc']], "pageLength": 50});
});

</script>

{% endblock %}

bitbake/lib/toaster/toastergui/templates/customise_btn.html
<button class="btn btn-default btn-block layer-exists-{{data.layer_version.pk}} customise-btn"  data-recipe="{{data.pk}}"
    {% if data.layer_version.pk not in extra.current_layers %}
    style="display:none;"
    {% endif %}
  >
  Customise
</button>
<button class="btn btn-default btn-block layer-add-{{data.layer_version.pk}} layerbtn"
    data-layer='{ "id": {{data.layer_version.pk}}, "name":  "{{data.layer_version.layer.name}}",
      "layerdetailurl": "{%url 'layerdetails' extra.pid data.layer_version.pk%}",
      "xhrLayerUrl": "{% url "xhr_layer" extra.pid data.layer_version.pk %}"}'
    data-directive="add"
    {% if data.layer_version.pk in extra.current_layers %}
    style="display:none;"
    {% endif %}
  >
  <i class="glyphicon glyphicon-plus"></i>
  Add layer
</button>

bitbake/lib/toaster/toastergui/templates/editcustomimage_modal.html
<!--
modal dialog shown on the build dashboard, for editing an existing custom image;
only shown if more than one custom image was built, so the user needs to
choose which one to edit

required context:
  build - a Build object
-->
<div class="modal fade" aria-hidden="false" id="edit-custom-image-modal">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
        <h3>Which image do you want to edit?</h3>
      </div>

      <div class="modal-body">
        {% for recipe in build.get_custom_image_recipes %}
        <div class="radio">
          <label>
            <input type="radio" name="select-custom-image"
                                data-url="{% url 'customrecipe' build.project.id recipe.id %}">
            {{recipe.name}}
          </label>
        </div>
        {% endfor %}
        <span class="help-block text-danger" id="invalid-custom-image-help" style="display:none">
          Please select a custom image to edit.
        </span>
      </div>

      <div class="modal-footer">
        <button class="btn btn-primary btn-lg" data-url="#"
                                               data-action="edit-custom-image" disabled>
          Edit custom image
        </button>
      </div>
    </div>
  </div>
</div>

<script>
$(document).ready(function () {
  var editCustomImageButton = $('[data-action="edit-custom-image"]');
  var error = $('#invalid-custom-image-help');
  var radios = $('[name="select-custom-image"]');

  // return custom image radio buttons which are selected
  var getSelectedRadios = function () {
    return $('[name="select-custom-image"]:checked');
  };

  function enableSubmit() {
    if (getSelectedRadios().length === 1) {
      editCustomImageButton.removeAttr('disabled');
      error.hide();
    }
    else {
      editCustomImageButton.attr('disabled', 'disabled');
      error.show();
    }
  };

  $("#edit-custom-image-modal").on("shown.bs.modal", function() {
    enableSubmit();
  });

  radios.change(function () {
    enableSubmit();
  });

  editCustomImageButton.click(function () {
    var selectedRadios = getSelectedRadios();

    if (selectedRadios.length === 1) {
      document.location.href = selectedRadios.first().attr('data-url');
    }
    else {
      error.show();
    }
  });

  // Select the first custom image listed. Radio button groups
  // should always have an option selected by default
  $("input:radio:first").attr("checked", "checked");

});
</script>

bitbake/lib/toaster/toastergui/templates/js-unit-tests.html
{% extends "base.html" %}
{% load projecttags %}
{% load humanize %}
{% load static %}
{% block pagecontent %}

<link rel="stylesheet" href="{% static 'css/qunit-1.18.0.css' %}" />

<script src="{% static 'js/qunit-1.18.0.js' %}"></script>

<script src="{% static 'js/layerDepsModal.js' %}"></script>
<script src="{% static 'js/projectpage.js' %}"></script>

<script src="{% static 'js/bootstrap-3.4.1.min.js' %}"></script>
<script src="{% static 'js/filtersnippet.js' %}"></script>
<script src="{% static 'js/importlayer.js' %}"></script>
<script src="{% static 'js/highlight.pack.js' %}"></script>
<script src="{% static 'js/layerBtn.js' %}"></script>
<script src="{% static 'js/layerDepsModal.js' %}"></script>
<script src="{% static 'js/projectpage.js' %}"></script>
<script src="{% static 'js/layerdetails.js' %}"></script>
<script src="{% static 'js/table.js' %}"></script>

<script>
  var ctx = {
    tableUrl : '{% url 'projectlayers' project.pk %}',
    projectId : {{project.pk}},
  }
</script>
<script src="{% static 'js/tests/test.js' %}"></script>

<div id="qunit"></div>

<input type="text" id="layers" placeholder="layers" ></input>
<input type="text" id="recipes" placeholder="recipes"></input>
<input type="text" id="projects" placeholder="projects"></input>
<input type="text" id="machines" placeholder="machines"></input>

<!-- import layer dependency input typeahead -->
<input type="text" id="layer-dependency" style="display:none"></input>
<!-- project page input typeaheads -->
<input type="text" id="layer-add-input" style="display:none"></input>
<input type="text" id="machine-change-input" style="display:none"></input>
<!-- import layer dependency input typeahead on layer details edit layer -->
<input type="text" id="layer-dep-input" style="display:none"></input>

{% endblock %}

bitbake/lib/toaster/toastergui/templates/recipe_add_btn.html
<a data-recipe-name="{{data.name}}" class="btn btn-default btn-block layer-exists-{{data.layer_version.pk}} set-default-recipe-btn" style="margin-top: 5px;
  {% if data.layer_version.pk not in extra.current_layers %}
    display:none;
  {% endif %}"
 >
  Set recipe
</a>
<a class="btn btn-default btn-block layerbtn layer-add-{{data.layer_version.pk}}"
  data-layer='{
  "id": {{data.layer_version.pk}},
  "name":  "{{data.layer_version.layer.name}}",
  "layerdetailurl": "{%url "layerdetails" extra.pid data.layer_version.pk%}",
   "xhrLayerUrl": "{% url "xhr_layer" extra.pid data.layer_version.pk %}"
   }' data-directive="add"
    {% if data.layer_version.pk in extra.current_layers %}
     style="display:none;"
    {% endif %}
>
  <span class="glyphicon glyphicon-plus"></span>
  Add layer
  <span class="glyphicon glyphicon-question-sign get-help" title="To set this
      recipe you must first add the {{data.layer_version.layer.name}} layer to your project"></i>
</a>